//Algorithmus.java
//die Superklasse aller Algorithmen;
import java.awt.*;
import java.awt.image.*;

class Algorithmus implements Runnable{
	protected BildKomp ziel;
	protected Image img;
	protected int breite, hoehe, alt_breite, alt_hoehe;
	protected int maskengroesse;
	protected int max, min, threshold;
	protected float maxf, minf;
	
	Algorithmus(Image img, BildKomp ziel){
		this.breite = img.getWidth(null);
		this.hoehe = img.getHeight(null);
		this.img = img;
		this.ziel = ziel;
	}
	
	Algorithmus(Image img, BildKomp ziel, int maskengroesse){
		this(img, ziel);
		this.maskengroesse = maskengroesse;
	}
	
	Algorithmus(Image img, BildKomp ziel, int maskengroesse, int threshold){
		this(img, ziel, maskengroesse);
		this.threshold = threshold;
	}
	
	public void run(){
			ziel.setImage(berechne());
	}
	
	protected Image berechne(){
		
		//für die Randbehandlung
		//Rand in Größe der halben Maske kopiert
		BufferedImage buffImgHelp = Rand.kopiereRand(img, maskengroesse, BufferedImage.TYPE_BYTE_GRAY);
		
		//Daten aus Bild holen
		Raster raster = buffImgHelp.getData();
		WritableRaster wraster = raster.createCompatibleWritableRaster();
		
		alt_breite = buffImgHelp.getWidth(null);
		alt_hoehe = buffImgHelp.getHeight(null);
		
		byte[] original = (byte[])raster.getDataElements(0, 0, alt_breite, alt_hoehe, null);
		original = berechneAlgo(original);
			
		//neu berechnete Bild 			
		wraster.setDataElements(0,0, alt_breite, alt_hoehe, original);
		buffImgHelp.setData(wraster);
		
		int m=maskengroesse/2;
		return buffImgHelp.getSubimage(m, m, breite, hoehe);
	}
	
	protected byte[] berechneAlgo(byte[] original){
		
		//Umwandlung des Bilddatenarrays in eine Matrix
		int[][] pixs = Util.feldZuIntMatrix(original, alt_breite, alt_hoehe);
		int[][] hilfe = new int[alt_breite][alt_hoehe];
		
		algorithmus(pixs, hilfe);
		rescaling(hilfe);
	   
		//Thresholding
		Threshold.thresholdSchwarzWeiss(hilfe, threshold, Threshold.EDGE_WHITE);
			
		return Util.matrixZuFeld(hilfe);
	}
	
	protected void algorithmus(int[][] pixs, int[][] hilfe){}
	
	//a*x + b = f(x)
	protected void rescaling(int[][] bild){
		float a, b;
		
		a = 255f / (max-min);
		b = a * min;
		
		for(int i=alt_breite-1; i >=0 ; i--)
			for(int j=alt_hoehe-1; j >= 0; j--)
				bild[i][j] = (int)(a*bild[i][j]+b);
	}
	
	protected void rescaling(float[][] bild){
		float a, b;
		a = 255f / (maxf-minf);
		b = a * minf;
		for(int i=alt_breite-1; i>=0; i--)
	  		for(int j=alt_hoehe-1; j>=0; j--)
	  			bild[i][j] = a*bild[i][j]+b;
	}	
}