//BildAuswahl2.java

import java.util.*;
import java.net.*;
import java.awt.*;
import javax.swing.*;

class BildAuswahl {
	
	private Vector bildKomp;
	private Hashtable bildImgs;
	private Image img;
	private FileOpener fop;
	private Segmentation f;
	private String first;
	
	BildAuswahl(Segmentation f){
		
		Vector bilder = f.getBilder();
		String verz = f.getVerzBild();
		URL codebase = f.getCodebase();
		this.f = f;
		
		bildKomp = new Vector();
		
		//Laden der Bilder: als (Name, Bild) in Hashtable bildImgs	
		bildImgs = new Hashtable();
		SortedSet filetypes = new TreeSet();
		for(int i=0; i < bilder.size(); i++){
			String name = (String)bilder.get(i);
			String pfad = verz+name;
			try{
				Image img = new ImageIcon(new URL(codebase, pfad)).getImage();
				//Bilder mit Ladeproblemen ignorieren
				if(img.getWidth(null) != -1){
					bildImgs.put(name, img);
					int index = name.lastIndexOf(".");
					String type = name.substring(index);
					filetypes.add(type);
				}
			} catch(MalformedURLException m){
				System.out.println("URL for the image "
								+name+" badly specified");
			}
		}		
		
		//Dateinamen nach Endungen sortieren: als
		//(Endung, Vector aus Dateinamen) in Hashtable inhalt
		Vector[] files = new Vector[filetypes.size()];
		Hashtable inhalt = new Hashtable();
		Set s = bildImgs.keySet();
		TreeSet set = new TreeSet(s);
		int i=0;
		for(Iterator j=filetypes.iterator();  j.hasNext(); ){
			files[i] = new Vector();
			String a = (String)j.next();
			for(Iterator z = set.iterator(); z.hasNext(); ){
				String name = (String)z.next();
				int index = name.lastIndexOf(".");
				String type = name.substring(index);
				if(a.equalsIgnoreCase(type))
					files[i].add(name);
			}
			if(a.equalsIgnoreCase(".gif"))
				inhalt.put("GIF Image Files (*.gif)", files[i]);
			else if(a.equalsIgnoreCase(".jpg"))
				inhalt.put("JPEG Image Files (*.jpg)", files[i]);
			else
				inhalt.put(a, files[i]);
			i++;
		}
		
		fop = new FileOpener(inhalt, f, true);
		
		first = fop.getFirstItem();
		img = (Image)bildImgs.get(first);
		for(int j=0; j < bildKomp.size(); j++)
			((BildKomp)bildKomp.get(j)).setImage(img);
	}
		
	public void open(){
		boolean b = fop.showDialog();
		if(b == FileOpener.APPROVE_OPTION){
			final String s = fop.getSelectedItem();
			img = (Image)bildImgs.get(s);
			SwingUtilities.invokeLater(new Runnable(){
				public void run(){
					for(int i=0; i < bildKomp.size(); i++)
						((BildKomp)bildKomp.get(i)).setImage(img);
					Oberflaeche ob = f.getOberflaeche();
					ob.setName(s);
					ob.getGlaettung().reset();
					ob.getAlgorithmen().neuberechnen();
				}
			});
		}
	}
		
	public void addBildKomp(BildKomp k){
		k.setImage(img);
		bildKomp.add(k);
		bildKomp.trimToSize();
	}
	
	public String getFirstImageName(){
		return first;
	}	
}