//BildKomp.java
//Komponente zum Anzeigen der Bilder
//Nutzt die Fähigkeit von JLabel, Bilder automatisch anzuzeigen

import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;

class BildKomp extends JPanel{
	private JLabel bild; 
	private final int maxBreite = 180;	//Maximale Breite der Bilder
	private final int maxHoehe = 150;	//Maximale Höhe der Bilder
	
	//Konstruktor:
	//Parameter: img --> anzuzeigende Bild
	//			 title --> Überschrift für das Bild
	BildKomp(Image img, String title, Color farbe){
   		bild = new JLabel();
   		setImage(img);
   		JLabel titel = new JLabel(title, JLabel.LEFT);
   		JPanel p = new JPanel();
   		if(farbe != null)
   			p.setBackground(farbe);
   		p.setLayout(new BoxLayout(p, BoxLayout.Y_AXIS));
   		p.add(Box.createVerticalStrut(6));
		p.add(titel);
		p.add(bild);
		setLayout(new FlowLayout());
		add(p);
	}
	    
    BildKomp(Image img, String title){
   		this(img, title, null);
	}
    
	public final Image getImage(){
    		return ((ImageIcon)bild.getIcon()).getImage();
	}
		
	public void setImage(Image img){
		Insets ins = getInsets();
		bild.setPreferredSize(new Dimension(maxBreite + ins.left + ins.right, 
							 		 maxHoehe  + ins.top  + ins.bottom));
		if((img ==null) || (img.getWidth(null) == -1)){
			bild.setIcon(null);
			bild.setText("Error: Image can't be displayed!");
		}
		else if ((img.getHeight(null) > maxHoehe) || (img.getWidth(null) > maxBreite)){
			bild.setIcon(null);
			bild.setText("Image too large to display!");
		}
			else{
				bild.setText(null);
				bild.setIcon(new ImageIcon(img));
			}
	}
		
	public void paintComponent(Graphics g){
		super.paintComponent(g);
	}
}