//Energy.java
//Law's texture energy measures

import java.awt.image.*;
import java.awt.*;

class Energy extends Algorithmus{

	private float[] kernel;
	private int kernelbreite = 5; //Breite der Kernels E5E5 .. R5L5
	private float norm;
	private float[][] E5L5R5 = {
	/* E5E5 */			{ 1,  2, 0, -2, -1,
						  2,  4, 0, -4, -2,
						  0,  0, 0,  0,  0,
						 -2, -4, 0,  4,  2,
						 -1, -2, 0,  2,  1},
		
	/* E5L5 */			{-1, -4,  -6, -4, -1,
						 -2, -8, -12, -8, -2,
						  0,  0,   0,  0,  0,
						  2,  8,  12,  8,  2,
						  1,  4,   6,  4,  1},
						 
	/* E5R5 */ 			{-1,  4,  -6,  4, -1,
						 -2,  8, -12,  8, -2,
						  0,  0,   0,  0,  0,
						  2, -8,  12, -8,  2,
						  1, -4,   6, -4,  1},
						 
	/* L5L5 */		/*	{ 1,  4,  6,  4, 1,
						  4, 16, 24, 16, 4,
						  6, 24, 36, 24, 6,
						  4, 16, 24, 16, 4,
						  1,  4,  6,  4, 1},*/
						  
	/* L5E5 */			{-1,  -2, 0,  2, 1,
						 -4,  -8, 0,  8, 4,
						 -6, -12, 0, 12, 6,
						 -4,  -8, 0,  8, 4,
						 -1,  -2, 0,  2, 1},
						 
	/* L5R5 */			{ 1,  -4,  6,  -4, 1,
						  4, -16, 24, -16, 4,
						  6, -24, 36, -24, 6,
						  4, -16, 24, -16, 4,
						  1,  -4,  6,  -4, 1},
						  
	/* R5R5 */			{ 1,  -4,   6,  -4,  1,
						 -4,  16, -24,  16, -4,
						  6, -24,  36, -24,  6,
						 -4,  16, -24,  16, -4,
						  1,  -4,   6,  -4,  1},
						  
	/* R5E5 */			{-1,  -2, 0,  2,  1,
						  4,   8, 0, -8, -4,
						 -6, -12, 0, 12,  6,
						  4,   8, 0, -8, -4,
						 -1,  -2, 0,  2,  1},
						 
	/* R5L5 */			{ 1,   4,   6,   4,  1,
						 -4, -16, -24, -16, -4,
						  6,  24,  36,  24,  6,
						 -4, -16, -24, -16, -4,
						  1,   4,   6,   4,  1},
	};
	
	Energy(Image img, BildKomp ziel, int maskengroesse, int which, int threshold){
		super(img, ziel, maskengroesse, threshold);
		this.kernel = E5L5R5[which];
	}
	
	protected Image berechne(){
		int length = kernel.length;
							  
		for(int i=length-1; i >=0; i--)
	  	    norm += Math.abs(kernel[i]);
		norm -= 1;
		
		int m=((maskengroesse - kernelbreite) < 0) ? kernelbreite : maskengroesse;
								  
		BufferedImage buffImgHelp = Rand.kopiereRand(img, m, BufferedImage.TYPE_BYTE_GRAY);
		BufferedImageOp energy = new ConvolveOp(new Kernel(kernelbreite, kernelbreite, kernel), ConvolveOp.EDGE_NO_OP, null);
		BufferedImage destination = energy.filter(buffImgHelp, null);
		
		//Daten aus Bild holen
		Raster raster = destination.getData();
		WritableRaster wraster = raster.createCompatibleWritableRaster();
		
		int alt_breite = breite;
		int alt_hoehe = hoehe;
		
		breite = destination.getWidth(null);
		hoehe = destination.getHeight(null);
		
		byte[] original = (byte[])raster.getDataElements(0,0, breite, hoehe, null);
		
		float[][] res = new float[breite][hoehe];
		int wn = maskengroesse/2;
		
		int[][] im = Util.feldZuIntMatrix(original, breite, hoehe);
		float val = 0, sum=0;
		for (int i=wn; i<=breite-wn-1; i++){
	  		for (int j=wn; j<=hoehe-wn-1; j++){
	  			sum=0;
	  			for(int x=-wn; x <=wn; x++)
	  				for(int y=-wn; y<=wn; y++){
	    				val = (float)im[i+x][j+y]/(float)norm;
	    				sum += Math.abs(val);
	    			}
	    		maxf = sum > maxf ? sum : maxf;
	    		minf = sum < minf ? sum : minf;
	    		res[i][j] = sum;
	    	}
		}
		
		rescaling(res);
		original = Util.matrixZuFeld(res);
		Threshold.thresholdSchwarzWeiss(original, threshold, Threshold.EDGE_WHITE);
		//neu berechnete Bild 			
		wraster.setDataElements(0,0, breite, hoehe, original);
		destination.setData(wraster);
		
		return destination.getSubimage(m/2, m/2, alt_breite, alt_hoehe);
	}
}