//Gauss.java

import java.awt.image.*;
import java.awt.Image;

class Gauss extends Algorithmus{
	
	Gauss(Image img, BildKomp ziel, int maskengroesse){
		super(img, ziel, maskengroesse);
	}
		
	protected Image berechne(){
		float[] gaussKernel;
				
		if (maskengroesse==3){
			float[] gaussKernel_3 ={0.25f, 0.5f,  0.25f};
			gaussKernel = gaussKernel_3;
		}
		else{ //maskengroesse == 5
			float[] gaussKernel_5 = {0.0625f, 0.25f, 0.375f, 0.25f, 0.0625f};
			gaussKernel = gaussKernel_5;
		}
		
		BufferedImage buffImgHelp = Rand.kopiereRand(img, maskengroesse, BufferedImage.TYPE_INT_RGB);
		
		//horizontale Berechnung
		BufferedImageOp gaussHorizontal = new ConvolveOp(new Kernel(maskengroesse, 1, gaussKernel), ConvolveOp.EDGE_NO_OP, null);
		BufferedImage destination = gaussHorizontal.filter(buffImgHelp, null);
		
		//vertikale Berechnung
		BufferedImageOp gaussVertikal = new ConvolveOp(new Kernel(1, maskengroesse, gaussKernel), ConvolveOp.EDGE_NO_OP, null);
		BufferedImage destination2 = gaussVertikal.filter(destination, null);
		
		int m = maskengroesse/2;
		return destination2.getSubimage(m, m, breite, hoehe);
	}
}