//Hintergrund.java
//Berechnung des Hintergrund
//als Differenz zwischen Kanten- und Texturen-Bild
//wobei Kanten und Texturen immer weiß sind in ihren Bildern

import java.awt.image.*;
import java.awt.Image;

class Hintergrund implements Runnable{
	
	private Image kanten, textur, original;
	private int breite, hoehe;
	private BildKomp ziel;
		
	public Hintergrund(Image original, Image kanten, Image textur, BildKomp ziel){
		breite = original.getWidth(null);
		hoehe = original.getHeight(null);
		this.original = original;
		this.kanten = kanten;
		this.textur = textur;
		this.ziel = ziel;
	}
	
	public void run(){
		ziel.setImage(berechne());
	}
	
	private BufferedImage berechne(){
		
		//Daten aus Originalbild holen
		BufferedImage buffImg = new BufferedImage(breite, hoehe, BufferedImage.TYPE_BYTE_GRAY);
		buffImg.createGraphics().drawImage(original, 0, 0, null);
		Raster raster = buffImg.getData();
		WritableRaster wraster = raster.createCompatibleWritableRaster();
		byte[] origin = (byte[])raster.getDataElements(0, 0, breite, hoehe, null);
		
		//Daten aus Kantenbild holen
		byte[] originalK = getBilddaten(kanten);
		
		//Daten aus Texturbild holen
		byte[] originalT = getBilddaten(textur);
		
		//byte[] ergebnis = new byte[breite*hoehe];
		byte[] ergebnis = berechneHintergrund(origin, originalK, originalT);
		
		//neu berechnete Bild 			
		wraster.setDataElements(0,0, breite, hoehe, ergebnis);
		buffImg.setData(wraster);
			
		return buffImg;
	}
		
	private byte[] berechneHintergrund(byte[] original, byte[] originalK, byte[] originalT){
		
		for(int i=original.length-1; i >= 0; i--){
			if((originalT[i] == (byte)255) || (originalK[i] == (byte)255))
				original[i] = (byte)0;
		}	
		return original;
	}
	
	private byte[] getBilddaten(Image img){
		
		BufferedImage b = new BufferedImage(breite, hoehe, BufferedImage.TYPE_BYTE_GRAY);
		b.createGraphics().drawImage(img, 0, 0, null);
		Raster r = b.getData();
		byte[] data = (byte[])r.getDataElements(0, 0, breite, hoehe, null);
		return data;
	}
}