//Median.java
//Median-Berechnung mittels 3x3 oder 5x5-Maske

import java.awt.image.*;
import java.awt.*;
import java.util.*;


class Median extends Algorithmus{
	private int m;
	Median(Image img, BildKomp ziel, int maskengroesse){
		super(img, ziel, maskengroesse);
		m=maskengroesse/2;
	}
	
	protected Image berechne(){
		
		BufferedImage buffImgHelp = Rand.kopiereRand(img, maskengroesse, BufferedImage.TYPE_INT_RGB);
		int alt_breite = breite;
		int alt_hoehe = hoehe;
		breite = buffImgHelp.getWidth(null);
		hoehe = buffImgHelp.getHeight(null);
		
		int[] rgbs = new int[breite*hoehe];
		buffImgHelp.getRGB(0, 0, breite, hoehe, rgbs, 0, breite);
		int[][] pixs = Util.feldZuMatrix(rgbs, breite, hoehe);
		pixs = berechneMedian(pixs);		
		
		rgbs = Util.matrixZuIntFeld(pixs);
    	buffImgHelp.setRGB(0, 0, breite, hoehe, rgbs, 0, breite);
    	return buffImgHelp.getSubimage(m, m, alt_breite, alt_hoehe);
	}
	
	private int[][] berechneMedian(int[][] pixs){
		int[][] hilfe = new int [breite][hoehe];
    	int[] maske = new int[maskengroesse*maskengroesse];
    	int mitte = (maskengroesse*maskengroesse)/2;
    	
    	for(int y=0; y <= hoehe-maskengroesse; y++){
    		for(int x=0; x <= breite-maskengroesse; x++){
    			for(int i=0; i < maskengroesse; i++)
        			System.arraycopy(pixs[x+i], y, maske, i*maskengroesse, maskengroesse);
        		Arrays.sort(maske);
        		hilfe[x+m][y+m] = maske[mitte];
        	}
        }  
        return hilfe;
    }
}