import javax.swing.*;
import javax.swing.border.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.net.*;

class Oberflaeche extends JPanel{
		
	private BildKomp original, smoothed, textur, kanten, hintergrund;
	private Glaettung glaettung;
	private Algorithmen algorithmen;
	private BildAuswahl chooser;
	private JLabel name;
						
	Oberflaeche(Segmentation segm){
		
		Color farbeK = new Color(153, 181, 220);
		Color farbeT = new Color(173, 216, 230);
		Color farbeB = new Color(189, 187, 225);
		
		//BildKomp-Objekte
		//eines für die Darstellung der Kanten-, 
		//eines für die Texturen und eins für die Flächenalgorithmen
		original = new BildKomp(null, "Original Image");
		smoothed = new BildKomp(null, "Smoothed Image");
		kanten = new BildKomp(null, "Edges", farbeK);
		textur = new BildKomp(null, "Textures", farbeT);
		hintergrund = new BildKomp(null, "Background", farbeB);
		
		chooser = new BildAuswahl(segm);
		chooser.addBildKomp(original);
		chooser.addBildKomp(kanten);
		chooser.addBildKomp(textur);
		chooser.addBildKomp(smoothed);
		chooser.addBildKomp(hintergrund);
		
		glaettung = new Glaettung(this);
		algorithmen = new Algorithmen(this);
		
		setLayout(new GridLayout(0,4));
		
		JPanel rechts = new JPanel();
		rechts.setLayout(new GridLayout(3,0, 0, 6));
		kanten.setBackground(farbeK);
		textur.setBackground(farbeT);
		hintergrund.setBackground(farbeB);
		rechts.add(kanten);
		rechts.add(textur);
		rechts.add(hintergrund);
		JPanel p = new JPanel();
		p.add(rechts, BorderLayout.NORTH);
		
		name = new JLabel(" Current file: "+chooser.getFirstImageName(), JLabel.LEFT);
		JPanel l = new JPanel();
		l.setLayout(new BoxLayout(l, BoxLayout.Y_AXIS));
   		l.add(original);
   		l.add(Box.createVerticalStrut(12));
   		JPanel jp = new JPanel();
   		jp.setLayout(new GridLayout(0,1));
		jp.add(name);
		l.add(jp);
		
		JPanel links = new JPanel();
		links.add(l, BorderLayout.NORTH);
					
		add(links);
		add(glaettung);
		add(algorithmen);
		add(p);
	}
	
	public void setName(String s){
		name.setText(" Current file: "+s);
	}

	public BildKomp getOriginal(){
		return original;
	}
	
	public BildKomp getKanten(){
		return kanten;
	}
	
	public BildKomp getTextur(){
		return textur;
	}
	
	public BildKomp getSmoothed(){
		return smoothed;
	}
	
	public BildKomp getHintergrund(){
		return hintergrund;
	}
	
	public Algorithmen getAlgorithmen(){
		return algorithmen;
	}
	
	public Glaettung getGlaettung(){
		return glaettung;
	}
	
	public BildAuswahl getBildAuswahl(){
		return chooser;
	}
}