//Rand.java
//Kopiert und erweitert die Bilder um Ränder
//entsprechend den anzuwendenden Filtermasken
//Bedingung an die Masken: quadratisch

import java.awt.*;
import java.awt.image.*;

class Rand{
	
	public static BufferedImage kopiereRand(Image img, int mask, int typ){
		int halb = mask/2;
			
		int breite = img.getWidth(null);
		int hoehe = img.getHeight(null);
		
		int max = breite < hoehe ? breite : hoehe;
		if ((max - halb) < 0)
			halb = max;
		int halbhoehe = halb+hoehe;
		int halbbreite = halb+breite;
		int hb2 = halb+halb;
			
		//Ziel-Bild
		BufferedImage buffImg = new BufferedImage(breite+hb2, hoehe+hb2, typ);
		Graphics g = buffImg.createGraphics();
		g.drawImage(img, halb, halb, null);
		
		//1. Hilfsbild, enthält Original
		BufferedImage bi1 = new BufferedImage(breite, hoehe, typ);
		Graphics g1 = bi1.createGraphics();
		g1.drawImage(img, 0, 0, null);
		DataBuffer db1 = bi1.getRaster().getDataBuffer();
		
		if(halb <= 0)
			return bi1;
		
		//2. Hilfsbild
        	BufferedImage bi2 = new BufferedImage(breite, halb, typ);
        	DataBuffer db2 = bi2.getRaster().getDataBuffer();
        
        	//3.Hilfsbild
        	BufferedImage bi22 = new BufferedImage(breite, halb, typ);
        	DataBuffer db22 = bi22.getRaster().getDataBuffer();
        
      	//spiegeln, x-Achse: Rand oben und unten
       	mirrorX(db1, db22, db2, halb, breite);
		g.drawImage(bi22, halb, 0, null);
		g.drawImage(bi2, halb, halbhoehe, null);	
		
		
		//4.+5. Hilfsbild
        	BufferedImage bi3 = new BufferedImage(halb, hoehe, typ);
       	DataBuffer db3 = bi3.getRaster().getDataBuffer();
        	BufferedImage bi33 = new BufferedImage(halb, hoehe, typ);
        	DataBuffer db33 = bi33.getRaster().getDataBuffer();
        
		//spiegeln, y-Achse: Rand links und rechts
		mirrorY(db1, db33, db3, halb, breite, hoehe);
		g.drawImage(bi33, 0, halb, null);
		g.drawImage(bi3, halbbreite, halb, null);
		
		//Ecken, entspricht spiegelung der Randbilder links und rechts
		//um die x-Achse
		BufferedImage ecke1 = new BufferedImage(halb, halb, typ);
		DataBuffer out = ecke1.getRaster().getDataBuffer();
		BufferedImage ecke2 = new BufferedImage(halb, halb, typ);
		DataBuffer out2 = ecke2.getRaster().getDataBuffer();
		mirrorX(db3, out, out2, halb, halb);
		g.drawImage(ecke1, halbbreite, 0, null);
		g.drawImage(ecke2, halbbreite, halbhoehe, null);
		
		mirrorX(db33, out, out2, halb, halb);
		g.drawImage(ecke1, 0, 0, null);
		g.drawImage(ecke2, 0, halbhoehe, null);
		
		return buffImg;
        
	}
	
	//out1: Bild für den oberen Rand
	//out2: Bild für den unteren Rand
	private static void mirrorX(DataBuffer in, DataBuffer out1, DataBuffer out2, int hb, int breite){
		int inSize = in.getSize();
		for(int k = hb-1; k>=0; k--){
			int kb = k*breite;
			for(int i=kb, j=hb*breite-breite-kb; i < breite+kb; i++, j++)
				out1.setElem(j, in.getElem(i));
			for(int i=inSize-1-kb, j=breite-1+kb; i > inSize-1-kb-breite; i--, j--)
				out2.setElem(j, in.getElem(i));
		}
	}
	
	//out1: Bild für den linken Rand
	//out2: Bild für den rechten Rand
	private static void mirrorY(DataBuffer in, DataBuffer out1, DataBuffer out2, int hb, int breite, int hoehe){
		for(int k=hoehe-1; k >= 0; k--){
			int kb = k*breite;
			for(int i= kb, j= hb*(k+1)-1; i < kb + hb; i++, j--)
				out1.setElem(j, in.getElem(i));
			for(int i=breite+kb-hb, j = hb-1+hb*k; i < breite + kb; i++, j--)
				out2.setElem(j, in.getElem(i));
		}
	}
}