//Robinson.java
/*	(-1  0  1)      ( 0  1  2)
	(-2  0  2)      (-1  0  1)
	(-1  0  1)      (-2 -1  0)

	( 1  0 -1)      ( 0 -1 -2)
	( 2  0 -2)      ( 1  0 -1)
	( 1  0 -1)      ( 2  1  0)

	(-1 -2 -1)      ( 2  1  0)
	( 0  0  0)      ( 1  0 -1)
	( 1  2  1)      ( 0 -1 -2)

	( 1  2  1)      (-2 -1  0)
	( 0  0  0)      (-1  0  1)
	(-1 -2 -1)      ( 0  1  2)*/

import java.awt.Image;
import java.util.*;

class Robinson extends Algorithmus{
		
	Robinson(Image img, BildKomp ziel, int threshold){
		super(img, ziel, 3, threshold);
	}
	
	protected void algorithmus(int[][] pixs, int[][] hilfe){
		for(int x=breite-2; x > 0; x--)
			for(int y=hoehe-2; y > 0; y--){
				int z = masks(pixs, y, x);
				max = z > max ? z : max;
	    			min = z < min ? z : min;
		   		hilfe[x][y] = z;
		   	}
	}

	//alle Masken auf Pixel(row, col) anwenden
	//und größten Wert zurückgeben
	private int masks(int[][] pixs, int row, int col){
		
		int resp[] = new int[8];
		
		int c_1 = col-1;	int c1 = col+1;
		int r_1 = row-1;	int r1 = row+1;
		
		resp[0] =  pixs[c1][r_1]+2*pixs[c1][row]+pixs[c1][r1]
			- (pixs[c_1][r_1]+2*pixs[c_1][row]+pixs[c_1][r1]);
				  
		resp[1] =  pixs[col][r_1]+2*pixs[c1][r_1]+pixs[c1][row]
			- (pixs[c_1][row]+2*pixs[c_1][r1]+pixs[col][r1]);
		
		resp[2] = -resp[0];
		
		resp[3] = -resp[1];
		
		resp[4] =  pixs[c_1][r1]+2*pixs[col][r1]+pixs[c1][r1]
			- (pixs[c_1][r_1]+2*pixs[col][r_1]+pixs[c1][r_1]);
				  
		resp[5] =  pixs[c_1][row]+2*pixs[c_1][r_1]+pixs[col][r_1]
			- (pixs[c1][row]+2*pixs[c1][r1]+pixs[col][r1]);
				   
		resp[6] = -resp[4];
				   
		resp[7] = -resp[5];
		
		Arrays.sort(resp);
		
		return resp[7];
	}
}