//SegmentationApplet.java

import java.awt.*;
import java.applet.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import java.net.*;


public class SegmentationApplet extends JApplet{
	private Vector bilder; //Dateinamen der Bilder
	private String verzBild; //Verzeichnis mit den Bildern
	private URL codebase; 	//URL, an der das Applet liegt
	private JButton start;  //Button, mit dem der Frame gestartet wird
	
	public void init(){
		//Auslesen der Appletparameter
		//Dateinamen der Bilder und
		//das Verzeichnis der Bilder
		bilder = getNamenBilder();
		verzBild = getVerzeichnisBilder();
		codebase = getCodeBase();
			
		start = new JButton("Load Segmentation Applet");
        	start.addActionListener(new ActionListener(){ 
             	public void actionPerformed(ActionEvent e){		
             		SwingUtilities.invokeLater(new Runnable(){
             			public void run(){
             			AppletContext ac = getAppletContext();
             			ac.showStatus("Loading Frame... ");
					JFrame segmentation=new Segmentation(bilder, verzBild, codebase);
					if(segmentation != null)
       					ac.showStatus("Frame loaded");
					}
				});
       			
       		}                                                     
        });
        
        JPanel pan = new JPanel();
        pan.setBackground(getColor());
        pan.add(start);
        getContentPane().add(pan, BorderLayout.CENTER);   
   	}
   	
    //Auslesen der Applet-Parameter aus der HTML-Seite
	private Vector getNamenBilder() {
	 	Vector bilder = new Vector(23); 
        int i = 0;                      
        String param = "IMAGE" + i;
        String wert;
        				
		while ((wert = getParameter(param)) != null){
        	bilder.addElement(wert);
            i++;
            param = "IMAGE" + i;
        }
        
        bilder.trimToSize();
        
        return bilder;
    }
   
	//Name des Verzeichnisses mit den Bildern
	private String getVerzeichnisBilder(){
		String verz;
		if ((verz = getParameter("IMAGEDIR")) != null)
            verz = verz + "/";
        else
        	verz = "";
        return verz;
    }
        
    //Hintergrundfarbe der HTML-Seite
    //Default: weiß
    private Color getColor(){
    	String c = getParameter("COLOR");
    	int r = 0, g=0, b =0;
    	if(c != null){
    		r = Integer.parseInt(c.substring(0,2), 16);
    		g = Integer.parseInt(c.substring(2,4), 16);
    		b = Integer.parseInt(c.substring(4,6), 16);
    		
    		return new Color(r, g, b);
    	}
    	else
    		return Color.white;
    }
}    