//Sobel.java
//Implementation des Sobel-Kanten-Detektors

import java.awt.Image;

class Sobel extends Algorithmus{
	
	Sobel(Image img, BildKomp ziel, int threshold){
		super(img, ziel, 3, threshold);
	}
	
	protected void algorithmus(int[][] pixs, int[][] hilfe){
						
		//Sobel berechnen
		int hb = maskengroesse/2;
		for(int x=breite-1-hb; x > 0; x--)
			for(int y=hoehe-1-hb; y > 0; y--){		
	    		int n = (pixs[x-1][y+1] + 2*pixs[x][y+1] + pixs[x+1][y+1]) -
	        			(pixs[x-1][y-1] + 2*pixs[x][y-1] + pixs[x+1][y-1]);
	    		int m = (pixs[x+1][y-1] + 2*pixs[x+1][y] + pixs[x+1][y+1]) -
	        			(pixs[x-1][y-1] + 2*pixs[x-1][y] + pixs[x-1][y+1]);
	    		int z = (int)(Math.sqrt(n*n + m*m)/4);
	    		max = z > max ? z : max;
	    		min = z < min ? z : min;
	    		hilfe[x][y] = z;
	 		}
	}
}